{

 Copyright 2020 Sammarco Francesco (francesco.sammarco@gmail.com)

 This file is part of Korg Remote Desktop.

 Korg Remote Desktop is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Korg Remote Desktop is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Korg Remote Desktop.  If not, see <http://www.gnu.org/licenses/>.

}

unit uaes128;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils

  //----------------------------------------------
  //necessari alla crittografia
  , DCPrijndael, DCPbase64, StrUtils, synacode
  //----------------------------------------------
  ;

type

    { TLazAES }

    TLazAES = class
        private
              mykey: ansistring;
        public
              constructor Create(key_p: ansistring);
              destructor Free;
              function EncriptAES128CTR(data: ansistring): ansistring;
              function DecriptAES128CTR(data: ansistring): ansistring;
    end;

implementation

{ TLazAES }

constructor TLazAES.Create(key_p: ansistring);
begin
     Self.mykey:=key_p;
end;

destructor TLazAES.Free;
begin

end;

function TLazAES.EncriptAES128CTR(data: ansistring): ansistring;
var
  Cipher : TDCP_rijndael;
  Key    : Ansistring;
  IV     : Ansistring;
  Data64 : AnsiString;
  num_ripetizioni: integer;
  variabile1, variabile2: single;
begin

  Key  := Self.mykey;
  IV   := AnsiReverseString(key);


  // Key <= 16 so adjust
  Key  := AddCharR(' ', Key  , 16);  //#0
  IV   := AddCharR(' ', IV   , 16);

  variabile1:=Length(Data)/16;
  variabile2:=Frac(variabile1);
  num_ripetizioni:=Trunc(variabile1-variabile2);
  if variabile2<>0 then
     num_ripetizioni:=num_ripetizioni + 1;
  if (num_ripetizioni=0) then
     num_ripetizioni:=num_ripetizioni + 1;



  Cipher := TDCP_rijndael.Create(nil);

  // Key <= 16 so adjust
  Cipher.Init(Key[1], 128, @IV[1]);
  Cipher.EncryptCTR(Data[1],Data[1],Length(Data));
  Cipher.Free;

  result := ansistring(Data);
end;

function TLazAES.DecriptAES128CTR(data: ansistring): ansistring;
var
  Cipher : TDCP_rijndael;
  Key    : Ansistring;
  IV     : Ansistring;
  Data64 : AnsiString;
  num_ripetizioni: integer;
  variabile1, variabile2: single;
begin

  Key  := Self.mykey;
  IV   := AnsiReverseString(key);


  // Key <= 16 so adjust
  Key  := AddCharR(' ', Key  , 16);  //#0
  IV   := AddCharR(' ', IV   , 16);

  variabile1:=Length(Data)/16;
  variabile2:=Frac(variabile1);
  num_ripetizioni:=Trunc(variabile1-variabile2);
  if variabile2<>0 then
     num_ripetizioni:=num_ripetizioni + 1;
  if (num_ripetizioni=0) then
     num_ripetizioni:=num_ripetizioni + 1;

  Cipher := TDCP_rijndael.Create(nil);

  // Key <= 16 so adjust
  Cipher.Init(Key[1], 128, @IV[1]);
  Cipher.DecryptCTR(Data[1],Data[1],Length(Data));
  Cipher.Free;

  result := ansistring(Data);
end;

end.

