{

 Copyright 2020 Sammarco Francesco (francesco.sammarco@gmail.com)

 This file is part of Korg Remote Desktop.

 Korg Remote Desktop is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Korg Remote Desktop is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Korg Remote Desktop.  If not, see <http://www.gnu.org/licenses/>.

}

unit uClientInfo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,blcksock,fphttpclient;

function myLocalComputerName(): String;
function myLocalIPAddress() : String;
function GetIpPub(): String;

implementation


function GetIpPub(): String;
var
  IdGetIP: TFPHTTPClient;
  Html : String;
const
  gUrlIpA= 'http://dynupdate.no-ip.com/ip.php';
  gUrlIpB= 'http://www.networksecuritytoolkit.org/nst/tools/ip.php';
begin
  try
  IdGetIP:=TFPHTTPClient.Create(nil);
  Result := '';
  try
    Html := IdGetIP.Get(gUrlIpA);
  except
    Html := IdGetIP.Get(gUrlIpB);
  end;
  Result := html;
  finally
    IdGetIP.Free;
  end;
end;

function myLocalComputerName():String;
var
  Sock : TUDPBlockSocket;
begin
  Sock := TUDPBlockSocket.Create;
  try
    result := sock.LocalName;
  finally
    if Assigned(Sock) then
    begin
      Sock.Free;
      Sock := nil;
    end;
  end;
end;

function myLocalIPAddress() : String ;
var
  Sock : TUDPBlockSocket;
  app  : TStringList;
begin
  result := '';
  Sock   := TUDPBlockSocket.Create;
  app    := TStringList.Create;
  try
    sock.ResolveNameToIP(sock.LocalName, app);
    result := app.Text;
  finally
    if Assigned(app) then
    begin
      app.Free;
      app := nil;
    end;

    if Assigned(Sock) then
    begin
      Sock.Free;
      Sock := nil;
    end;
  end;
end;


end.

