{

 Copyright 2020 Sammarco Francesco (francesco.sammarco@gmail.com)

 This file is part of Korg Remote Desktop.

 Korg Remote Desktop is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Korg Remote Desktop is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Korg Remote Desktop.  If not, see <http://www.gnu.org/licenses/>.

}

unit uScreenImage;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Graphics, LCLIntf, LCLType, function_base64;

function GetScreenImage(): string;

implementation

function GetScreenImage(): string;
var
  MyImg    : TJpegImage;
  ScreenDC : HDC;
  MS       : TMemoryStream;
  ret      : string;
begin
  ret:='';

  MyImg := TJpegImage.Create;
  MS := TMemoryStream.Create;
  MS.Position:=0;
  ScreenDC := GetDC(0);

  try
     try

        MyImg.LoadFromDevice(ScreenDC);

        MyImg.CompressionQuality:=25; //100 = best quality, 25 = pretty awful

        MyImg.SaveToStream(MS);
        ret:=StreamToBase64(MS);

     finally

       MS.Free;
       MyImg.Free;
       ReleaseDC(0,ScreenDC);
    end;
  except
        on E: Exception do
        begin

           ret := '';

        end;
  end;

  result:=ret;
end;

end.

